import java.applet.Applet;
import java.applet.AudioClip;
import java.net.URL;

import javax.sound.midi.MidiSystem;
import javax.sound.midi.Sequencer;


public class MusicPlayer extends Applet {
	static final long serialVersionUID = 857372426L;
	private Sequencer sequencer;
	private AudioClip se;
	public void init(){
		Sequencer s = null;
		try{s = MidiSystem.getSequencer(); s.open();} catch (Exception e){e.printStackTrace();}
		sequencer = s;
		se = null;
	}
	public void StopBGM(){sequencer.stop();}
	public void LoopBGM(String path){
		PlayBGM(path, Sequencer.LOOP_CONTINUOUSLY);
	}
	public void PlayBGM(String path, int ct){
		try{
			sequencer.stop();
			sequencer.setSequence(MidiSystem.getSequence(new URL(getCodeBase(), path)));
			sequencer.start();
			sequencer.setLoopCount(ct);
		}catch(Exception e){e.printStackTrace();}
	}
	public void PlaySE(String path){
		try{
			if(se != null) se.stop();
			se = getAudioClip(new URL(getCodeBase(), path));
			se.play();
		}catch(Exception e){}
	}
	public void LoopSE(String path){
		try{
			if(se != null) se.stop();
			se = getAudioClip(new URL(getCodeBase(), path));
			se.loop();
		}catch(Exception e){}
	}
	public void StopSE(){if(se != null) se.stop(); se = null;}
}
