var tileFrame = 0, elemFrame = 0;
setTimeout('animTiles()', 300);
setTimeout('animEvents()', 100*speed_mod);

function getMoveUpTile(tile){return 'background-position:'+elemFrame+'px 0px;';}

var animTileList = new Array(), animElemList = new Array(), sponsor_sprite = false, allowMovePause = false;
function addList(list, elem){
	for(var i=0; i<list.length; i++)
		if(list[i] == elem) return;
	list[list.length] = elem;
}
function addAnimElem(elem){
	if(elem.getAttribute('moveUp') == '1' || elem.getAttribute('tileanim') == '1' || elem.animfunc != 0){
		if(elem.getAttribute('tileanim') == '1') addList(animTileList, elem); else addList(animElemList, elem);
	}
	
}
function updateAnimElemList(){
	animTileList = new Array();
	animElemList = new Array();
	var elements = gameWindow.getElementsByTagName("div");
	for(var i=0; i<elements.length; i++){
		var elem = elements[i];
		addAnimElem(elem);
	}
	if(sponsor_sprite) addAnimElem(sponsor_sprite);
}

function animTiles(){
	if(doAnimTiles){
		tileFrame = (tileFrame+1)%4;
		var num = 0;
		for(var i=0; i<animTileList.length; i++){
			var elem = animTileList[i];
			if(!elem || !elem.parentNode || elem.getAttribute('tileanim') != '1'){num++; continue;}
			var ar = elem.style.backgroundPosition.split(" ");
			var x = -parseInt(ar[0]);
			x -= Math.floor(x*0.0104166667)*96;
			elem.style.backgroundPosition = (-x-tileFrame*96)+'px '+ar[1];
			if(num > 0) animTileList[i-num] = animTileList[i];
		}
		for(var i=0; i<num; i++) animTileList.pop();
	}
	setTimeout('animTiles()', 300);
}

function animEvents(){
	elemFrame = (elemFrame+1)%32;
	var num = 0;
	for(var i=0; i<animElemList.length; i++){
		var elem = animElemList[i];
		if(!elem || !elem.parentNode){num++; continue;}
		var isAnim = false;
		if(elem.getAttribute('moveUp') == '1'){
			if(typeof(elem.y) != 'undefined'){elem.y++; elem.style.backgroundPosition = elem.y+"px "+elem.y+"px";}else
			elem.style.backgroundPosition = (elemFrame*2)+'px 0px';
			isAnim = true;
		}
		if((elem.animfunc == 1) | (elem.animfunc == 3)){
			if(elemFrame%Math.floor(elem.framems/100) == 0){
				var frame = (elem.frame+((elem.reverse)?3:1))%4;
				if((elem.animfunc == 3) & (frame == elem.stframe)){
					elem.animfunc = 0; if(elem.callback){elem.callbackfunc = elem.callback; elem.callback = null; elem.callbackfunc(); elem.callbackfunc = null;}
				}
				else elem.setFrame(frame);
			}
			isAnim = true;
		}
		else if((elem.animfunc == 2) | (elem.animfunc == 4)){
			if(elemFrame%Math.floor(elem.framems/100) == 0){
				var facing = (elem.facing+((elem.reverse)?3:1))%4;
				if((elem.animfunc == 4) & (facing == elem.stdir)){
					elem.animfunc = 0; if(elem.callback){elem.callbackfunc = elem.callback; elem.callback = null; elem.callbackfunc(); elem.callbackfunc = null;}
				}
				else elem.setDir(facing);
			}
			isAnim = true;
		}
		else if(elem.animfunc == 5){
			elem.stalpha--;
			if(elem.stalpha <= 0){
				elem.animfunc = 0; if(!elem.keepAlive) removeEvent(elem); if(elem.callback){elem.callbackfunc = elem.callback; elem.callback = null; elem.callbackfunc(); elem.callbackfunc = null;}
			}
			else{elem.style.opacity=elem.stalpha/10; if(elem.filters && elem.filters.alpha) elem.filters.alpha.opacity=elem.stalpha*10;}
			isAnim = true;
		} else if(elem.animfunc == 6){
			elem.stalpha--; if(elem.stalpha <= 0){if(elem.callback){elem.callbackfunc = elem.callback; elem.callback = null; elem.callbackfunc(); elem.callbackfunc = null;} elem.parentNode.removeChild(elem);} else {
				elem.y+=2; elem.style.bottom = elem.y+'px';
				var alpha = Math.min(elem.stalpha, 10);
				elem.style.opacity=alpha/10; if(elem.filters && elem.filters.alpha) elem.filters.alpha.opacity=elem.stalpha*10;
			}
			isAnim = true;
		} else if(elem.animfunc == 7){
			isAnim = true;
			elem.stalpha++; if(elem.stalpha > 10) {elem.animfunc = 0;
				if(elem.callback){elem.callbackfunc = elem.callback; elem.callback = null; elem.callbackfunc(); elem.callbackfunc = null;}
			} else {
				elem.style.opacity=elem.stalpha/10; if(elem.filters && elem.filters.alpha) elem.filters.alpha.opacity=elem.stalpha*10;
			}
		} else if(elem.animfunc == 8){
			if(elem.facing != 0) elem.setDir(0);
			isAnim = true;
			if(elemFrame%Math.floor(elem.framems/100) == 0){
				if(elem.y < -elem.height) elem.fadeAnim(); else{setY(elem, elem.y-elem.stepsize);elem.setFrame((elem.frame+1)%4);}
			}
		} else if(elem.animfunc == 9){
			if(elem.facing != 3) elem.setDir(3);
			isAnim = true;
			if(elemFrame%Math.floor(elem.framems/100) == 0){
				if(elem.y > worldY) elem.fadeAnim(); else{setY(elem, elem.y+elem.stepsize);elem.setFrame((elem.frame+1)%4);}
			}
		}
		if(isAnim){if(num > 0) animElemList[i-num] = animElemList[i];} else{elem.animfunc = 0; num++;}
	}
	for(var i=0; i<num; i++) animElemList.pop();
	setTimeout('animEvents()', 100*speed_mod);
}

function fadeIn(event){
	event.style.opacity = 0;
	event.style.filter="alpha(opacity=0)";
	var olda = event.animfunc;
	event.animfunc = 7; event.stalpha = 0;
	if(olda == 0) addAnimElem(event);
}

//movement patterns

setTimeout('movementPattern()', 100*speed_mod);

var movementList = new Array();
function addMovementList(elem){
	if(elem.movement != 0){
		for(var i=0; i<movementList.length; i++)
			if(movementList[i] == elem) return;
		movementList[movementList.length] = elem;
	}
}

function movementPattern(){
	var num = 0;
	for(var i=0; i<movementList.length; i++){
		var obj = movementList[i];
		if(!obj || !obj.parentNode){num++; continue;}
		if(obj.movement != 0){
			var x = getX(obj);
			var y = getY(obj);
			var step_size = obj.stepsize;
			var dir, blocked = false;
			if((x != Math.floor(x)) | (y != Math.floor(y))) dir = obj.facing;
			else{
				if(!inBattle && (allowMovePause | !gamePaused())){
					dir = Math.floor(Math.random()*6);
					if(dir > 3) obj.waitframes = 5;
					if(obj.waitframes){obj.waitframes--; blocked = true;}
					else {
						obj.setDir(dir);
						var tx = x+getDirX(dir);
						var ty = y+getDirY(dir);
						if(tx < 0 || tx >= worldX || ty < 0 || ty >= worldY) blocked = true;
						else if(obj.blocker == 1){
							if(worldGrid[ty*worldX+tx] != null) blocked = true;
							else {worldGrid[obj.y*worldX+obj.x] = null; worldGrid[ty*worldX+tx] = obj;}
						}
						if(!blocked) if(obj.inrange){var p = getPlayerUnit(); obj.inrange(dist(x, y, p.x, p.y));}
					}
				} else blocked = true;
			}
			if(!animating && !blocked){
				x += step_size*getDirX(dir);
				y += step_size*getDirY(dir);
				setX(obj, x); setY(obj, y);
				var frame = obj.frame;
				if(obj.animfunc == 0) frame = (frame+1)%4;
				obj.style.backgroundPosition = (-frame*obj.width)+'px '+(-obj.facing*obj.height)+'px';
				obj.frame = frame;
			}
			if(num > 0) movementList[i-num] = obj;
		} else num++;
	}
	for(var i=0; i<num; i++) movementList.pop();
	setTimeout('movementPattern()', 100*speed_mod);
}

//weapon animations

var ANIM_SIZE = 192, animationCallback, sprites;

function animSprite(x, y, img, i, offX, offY, layer){
	var sprite = document.createElement("div");
	sprite.className = 'animsprite';
	sprite.style.backgroundImage = "url('images/Animations/"+img+"')";
	sprite.setIndex = function(i){this.index=i; var x = -(i%5)*ANIM_SIZE; var y = -Math.floor(i/5)*ANIM_SIZE; this.style.backgroundPosition = x+'px '+y+'px';};
	sprite.setPos = function(x, y){this.style.left = x; this.style.bottom = y;};
	sprite.setIndex(i);
	offX = (typeof(offX) != 'undefined')?offX:0.5;
	offY = (typeof(offY) != 'undefined')?offY:0.5;
	layer = (typeof(layer) != 'undefined')?layer:1;
	var animX = TILE_SIZE*x-(ANIM_SIZE-TILE_SIZE)*offX;
	var animY = TILE_SIZE*y-(ANIM_SIZE-TILE_SIZE)*offY;
	sprite.setPos(animX, animY);
	layers[layer*worldY+Math.ceil(y)].appendChild(sprite);
	return sprite;
}

function singleAnim(x, y, img, st, end, offX, offY, layer){
	showAnim();
	var image = new Image();
	var i = sprites.length;
	sprites[i] = animSprite(x,y,img,st,offX,offY,layer);
	image.onload = function(){setTimeout("simpleAnim("+i+", "+end+", 0, 0)", 60*speed_mod);}
	image.src = "images/Animations/"+img;
}

function singleFadeAnim(x, y, img, st, end, offX, offY, layer){
	showAnim();
	var image = new Image();
	var i = sprites.length;
	sprites[i] = animSprite(x,y,img,st,offX,offY,layer);
	sprites[i].stalpha = 10;
	image.onload = function(){setTimeout("fadeAnim("+i+", "+end+", 0, 0)", 60*speed_mod);}
	image.src = "images/Animations/"+img;
}


function loopAnim(x, y, img, st, end, stloop, loopct, offX, offY, layer){
	showAnim();
	var image = new Image();
	var i = sprites.length;
	sprites[i] = animSprite(x,y,img,st,offX,offY,layer);
	image.onload = function(){setTimeout("simpleAnim("+i+", "+end+", "+stloop+", "+loopct+")", 60*speed_mod);}
	image.src = "images/Animations/"+img;
}

function singleRevAnim(x, y, img, st, end, revst, offX, offY, layer){
	showAnim();
	var image = new Image();
	var i = sprites.length;
	sprites[i] = animSprite(x,y,img,st,offX,offY,layer);
	image.onload = function(){setTimeout("reverseAnim("+i+", "+st+", "+end+", "+revst+", 0)", 60*speed_mod);}
	image.src = "images/Animations/"+img;
}

function singleDropAnim(x, y, img, st, height, pixels, offX, offY, layer){
	showAnim();
	var image = new Image();
	var i = sprites.length;
	sprites[i] = animSprite(x,y,img,st,offX,offY,layer);
	sprites[i].style.bottom = parseInt(sprites[i].style.bottom)+pixels;
	image.onload = function(){setTimeout("dropAnim("+i+", "+height+", "+pixels+")", 60*speed_mod);}
	image.src = "images/Animations/"+img;
}

function blowAnim(x, y){playSE("audio/sound/Blow1.wav"); singleAnim(x, y, "Attack5.png", 0, 7);}
function peckAnim(x, y){playSE("audio/sound/Chicken.wav"); blowAnim(x, y);}
function elecBlowAnim(x, y){playSE("audio/sound/Thunder7.wav"); singleAnim(x, y, "Attack4.png", 0, 7);}
function punchAnim(x, y){playSE("audio/sound/Blow6.wav"); singleAnim(x, y, "Blow1.png", 0, 6, 0.3);}
function biteAnim(x, y){playSE("audio/sound/Bite.wav"); singleAnim(x, y, "005-Attack03.png", 0, 5);}
function swordAnim(x, y){playSE("audio/sound/Sword3.wav"); singleAnim(x, y, "Sword1.png", 0, 6, 0.55);}
function spearAnim(x, y){playSE("audio/sound/Kill8.wav"); singleAnim(x, y, "Spear1.png", 0, 9);}
function axeAnim(x, y){playSE("audio/sound/Kill2.wav"); singleAnim(x, y, "Sword1.png", 0, 6, 0.55);}
function slingAnim(x, y){playSE("audio/sound/Wind7.wav"); showAnim(); setTimeout("spearAnim("+x+","+y+")", 200*speed_mod);}
function throwAnim(x, y){
	playSE("audio/sound/Wind7.wav");
	showAnim();
	setTimeout("playSE('audio/sound/Wind7.wav')", 200*speed_mod);
	setTimeout("playSE('audio/sound/Wind7.wav')", 400*speed_mod);
	setTimeout("spearAnim("+x+","+y+")", 600*speed_mod);
}
function bowAnim(x, y){playSE("audio/sound/Bow1.wav"); showAnim(); setTimeout("spearAnim("+x+","+y+")", 600*speed_mod);}
function crossbowAnim(x, y){playSE("audio/sound/Bow2.wav"); showAnim(); setTimeout("spearAnim("+x+","+y+")", 600*speed_mod);}

function healAnim(x, y){playSE("audio/sound/Holy6.wav"); if(typeof(y) != 'undefined') singleAnim(x, y, "Heal1.png", 18, 30, 0.5, 0.2);}
function upAnim(x, y){playSE("audio/sound/Up.wav"); singleAnim(x, y, "Special1b.png", 0, 14, 0.5, 0.5, 0);}
function downAnim(x, y){playSE("audio/sound/Down.wav"); singleAnim(x, y, "Special1.png", 0, 14, 0.5, 0.5, 0);}
function bindAnim(x, y){playSE("audio/sound/Kill5.wav"); singleAnim(x, y, "Special9.png", 0, 9, 0.5, 0.2);}
function cureAnim(x, y){playSE("audio/sound/Recovery6.wav"); singleAnim(x, y, "Heal3.png", 19, 25, 0.5, 0.2);}
function reviveAnim(x, y){playSE("audio/sound/Rebirth2.wav"); if(typeof(y) != 'undefined') singleAnim(x, y, "Heal3.png", 0, 11, 0.5, 0.5);}
function tameAnim(x, y){playSE("audio/sound/Holy1.wav"); singleAnim(x, y, "Heal4.png", 0, 22);}

function fireAnim1(x, y){playSE("audio/sound/Flame1.wav"); singleAnim(x, y, "Fire1.png", 0, 6, 0.5, 0.3);}
function fireAnim2(x, y){playSE("audio/sound/Flame8.wav"); singleAnim(x, y, "Special2.png", 5, 15);}
function waterAnim1(x, y){playSE("audio/sound/Water1.wav"); setTimeout("singleAnim("+x+", "+y+", 'Water1.png', 7, 15)", 180*speed_mod); singleAnim(x, y, "Water1.png", 0, 7);}
function waterAnim2(x, y){playSE("audio/sound/Cold2.wav"); playSE("audio/sound/Cold8.wav"); singleAnim(x, y, "Ice4.png", 0, 6, 0.5, 0.2); singleFadeAnim(x, y, "Ice4.png", 5, 8, 0.5, 0.2); setTimeout("singleAnim("+x+", "+y+", 'Ice4.png', 8, 13, 0.5, 0.2)", 180);}
function earthAnim1(x, y){singleDropAnim(x,y, "Earth1.png", 1, 90, 30, 0.5, 0.4); setTimeout("playSE('audio/sound/Earth1.wav');singleAnim("+x+", "+y+", 'Earth1.png', 2, 7, 0.5, 0.4)", 180*speed_mod);}
function earthAnim2(x, y){playSE("audio/sound/Earth5.wav"); loopAnim(x, y, "Earth2.png", 0, 2, 1, 9, 0.5, 0.2); singleRevAnim(x, y, "Earth2.png", 0, 7, 3, 0.5, 0.2);}
function airAnim1(x, y){playSE("audio/sound/Wind1.wav"); singleAnim(x, y, "Wind1.png", 0, 8); setTimeout("singleAnim("+x+", "+y+", 'Wind1.png', 8, 14)", 300*speed_mod);}
function airAnim2(x, y){playSE("audio/sound/Thunder9.wav"); loopAnim(x, y, "Thunder1.png", 9, 12, 9, 2, 0.5, 0.2); loopAnim(x, y, "Thunder1.png", 6, 9, 8, 6, 0.5, 0.2);}
function holyAnim(x, y){playSE("audio/sound/Holy7.wav"); singleAnim(x, y, "Light1.png", 0, 15);}
function evilAnim(x, y){playSE("audio/sound/Dark5.wav"); singleAnim(x, y, 'Death1.png', 12, 22); setTimeout("singleFadeAnim("+x+", "+y+", 'Death1.png', 5, 11)", 360*speed_mod);}

function explosionAnim(x, y){playSE("audio/sound/Explosion4.wav"); singleAnim(x, y, "Fire2.png", 0, 12);}
function lvlUpAnim(x, y){playSE("audio/sound/Up.wav"); singleRevAnim(x, y, "Heal1.png", 4, 7, 5, 0.5, 0.2);}
function locateAnim(x, y){playSE("audio/sound/Holy3.wav"); singleAnim(x, y, "Heal6.png", 0, 10, 0.5, 0.6);}
function portalAnim(x, y){playSE("audio/sound/Dark3.wav"); loopAnim(x, y, "Darkness1.png", 0, 4, 0, 1); setTimeout("singleAnim("+x+", "+y+", 'Darkness1.png', 4, 9)", 480*speed_mod);}

function simpleAnim(i, end, stloop, loopct){
	if(i >= sprites.length || !sprites[i]) return;
	var idx = sprites[i].index+1;
	if(idx >= end) if(loopct > 0){loopct--; idx = stloop;} else {endAnim(i); return;}
	sprites[i].setIndex(idx);
	setTimeout("simpleAnim("+i+","+end+", "+stloop+", "+loopct+")", 60*speed_mod);
}

function fadeAnim(i, end, stloop, loopct){
	if(i >= sprites.length || !sprites[i]) return;
	var idx = sprites[i].index+1;
	if(idx >= end){
		if(loopct > 0){loopct--; idx = stloop;} else {
			if(sprites[i].stalpha <= 0){endAnim(i); return;}
			sprites[i].stalpha--;
			sprites[i].style.opacity=sprites[i].stalpha/10;
		}
	} else sprites[i].setIndex(idx);
	setTimeout("fadeAnim("+i+","+end+", "+stloop+", "+loopct+")", 60*speed_mod);
}

function reverseAnim(i, st, end, revst, inrev){
	if(i >= sprites.length || !sprites[i]) return;
	var idx = sprites[i].index;
	if(inrev == 1) idx--; else idx++;
	if(idx >= end){inrev = 1; idx = revst;}
	if(idx <= st){endAnim(i); return;}
	sprites[i].setIndex(idx);
	setTimeout("reverseAnim("+i+","+st+", "+end+", "+revst+", "+inrev+")", 60*speed_mod);
}

function dropAnim(i, height, pixels){
	if(i >= sprites.length || !sprites[i]) return;
	if(height <= pixels){endAnim(i); return;}
	sprites[i].style.bottom = parseInt(sprites[i].style.bottom)-pixels;
	setTimeout("dropAnim("+i+", "+(height-pixels)+", "+pixels+")", 60*speed_mod);
}

function showAnim(){
	if(gamePaused()) return;
	sprites = new Array();
	pauseGame();
}

function endAnim(i){
	if(sprites[i]){sprites[i].parentNode.removeChild(sprites[i]); sprites[i] = false;}
	for(var c=0; c<sprites.length; c++) if(sprites[c]) return;
	sprites = [];
	resumeGame();
	if(animationCallback) animationCallback();
}