var TILE_SIZE = 32, INV_TILE_SIZE = 0.03125;
var worldX = 20, worldY = 15;
var speed_mod = 1, doAnimTiles = true;

function arRemove(ar, obj){
	var found = false;
	for(var i=0; i<ar.length; i++)
		if(found) ar[i-1] = ar[i];
		else if(ar[i] == obj) found = true;
	if(found) ar.pop();
}

function escapeStr(str) {
str=str.replace(/\\/g,'~0');
str=str.replace(/\'/g,'~1');
str=str.replace(/\"/g,'~2');
str=str.replace(/\0/g,'~3');
str=str.replace(/\n/g, '~4');
str=str.replace(/\r/g, '');
str=str.replace(/\t/g, '~5');
str=str.replace(/\&/g, '~6');
str=str.replace(/\+/g, '~7');
str=str.replace(/\=/g, '~8');
return str;
}
function unescapeStr(str) {
str=str.replace(/~0/g,'\\');
str=str.replace(/~1/g,'\'');
str=str.replace(/~2/g,'\"');
str=str.replace(/~3/g,'\0');
str=str.replace(/~4/g, '\n');
str=str.replace(/~5/g, '\t');
str=str.replace(/~6/g, '&');
str=str.replace(/~7/g, '+');
str=str.replace(/~8/g, '=');
return str;
}

function getStyleClass(className) {
	className = className.toLowerCase();
	for (var s = 0; s < document.styleSheets.length; s++)
	{
		if(document.styleSheets[s].rules)
		{
			for (var r = 0; r < document.styleSheets[s].rules.length; r++)
			{
				if (document.styleSheets[s].rules[r].selectorText.toLowerCase() == '.' + className)
				{
					return document.styleSheets[s].rules[r];
				}
			}
		}
		else if(document.styleSheets[s].cssRules)
		{
			for (var r = 0; r < document.styleSheets[s].cssRules.length; r++)
			{
				if (document.styleSheets[s].cssRules[r].selectorText.toLowerCase() == '.' + className)
					return document.styleSheets[s].cssRules[r];
			}
		}
	}

	return null;
}

function setCookie(name, value, expires, path, domain, secure) {
if(!expires){expires = new Date(); expires.setFullYear(2036,0,31);}
document.cookie= name + "=" + escape(value) +
((expires) ? "; expires=" + expires.toGMTString() : "") +
((path) ? "; path=" + path : "") +
((domain) ? "; domain=" + domain : "") +
((secure) ? "; secure" : "");
}

function getCookie(name) {
var dc = document.cookie;
var prefix = name + "=";
var begin = dc.indexOf("; " + prefix);
if (begin == -1) {
begin = dc.indexOf(prefix);
if (begin != 0) return null;
} else {
begin += 2;
}
var end = document.cookie.indexOf(";", begin);
if (end == -1) {
end = dc.length;
}
return unescape(dc.substring(begin + prefix.length, end));
}